
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>无废话C#设计模式之十一：Composite / iVAN</title>

    <meta name="description" content="无废话C#设计模式之十一：Composite 意图 将对象组合成树形结构以表示&quot;部分-整体&quot;的层次结构.Composite模式使得用户对单个对象和组合对象的使用具有一致性. 场景 我们知道,一个网络游戏通常会有多个游戏大区.每一个游戏大区会有很多游戏服务器(一个游戏大区就是一组游戏服务器).每一个游戏服务器上会有不同的服务(可以是多个服务).这是一个明显的部分-整体关系,假设我们现在需要制作一个服务器管理工具,用于显示所有大区.服务器以及服务的信息,并且能开启这些服务(可以是单独开启一个服务,也可以是开启整个服务器上的所 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">无废话C#设计模式之十一：Composite</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>意图</p>
<p>将对象组合成树形结构以表示“部分-整体”的层次结构。Composite模式使得用户对单个对象和组合对象的使用具有一致性。</p>
<p>场景</p>
<p>我们知道，一个网络游戏通常会有多个游戏大区。每一个游戏大区会有很多游戏服务器（一个游戏大区就是一组游戏服务器）。每一个游戏服务器上会有不同的服务（可以是多个服务）。这是一个明显的部分-整体关系，假设我们现在需要制作一个服务器管理工具，用于显示所有大区、服务器以及服务的信息，并且能开启这些服务（可以是单独开启一个服务，也可以是开启整个服务器上的所有服务，也可以是开启整个大区的所有服务）。</p>
<p>可以看到，游戏服务器和游戏大区都是一个组合对象，而游戏服务是最底层的节点。客户端在开启一个游戏大区服务的时候，必须和游戏服务器以及游戏服务进行依赖，而在开启游戏服务器上所有服务的时候，必须和游戏服务进行依赖。试想一下，如果一个公司的总裁在管理上不但需要和各总监以及经理进行沟通，还有和底层的员工沟通，那么总裁是不是会太忙碌了一点？由此，我们引入组合模式，使组合对象和单个对象具有一样的表现形式。</p>
<p>示例代码</p>
<p><code>using System;</p>
<p>using System.Collections.Generic;</p>
<p>using System.Text;</p>
<p>namespace CompositeExample</p>
<p>{</p>
<p>　　　 class Program</p>
<p>　　　 {</p>
<p>　　　　　　　 static void Main(string[] args)</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 Element server1 = new GameServer("GS1", "192.168.0.1");</p>
<p>　　　　　　　　　　　 server1.Add(new GameService("Lobby1", 1, "S5Lobby1"));</p>
<p>　　　　　　　　　　　 server1.Add(new GameService("Gate1", 2, "S5Gate1"));</p>
<p>　　　　　　　　　　　 server1.Add(new GameService("DataExchange1", 3, "S5DataExchange1"));</p>
<p>　　　　　　　　　　　 server1.Add(new GameService("Rank1", 4, "S5Rank1"));</p>
<p>　　　　　　　　　　　 server1.Add(new GameService("Log1", 5, "S5Log1"));</p>
<p>　　　　　　　　　　　 Element server2 = new GameServer("GS2", "192.168.0.2");</p>
<p>　　　　　　　　　　　 server2.Add(new GameService("Lobby2", 1, "S5Lobby2"));</p>
<p>　　　　　　　　　　　 server2.Add(new GameService("Gate2", 2, "S5Gate2"));</p>
<p>　　　　　　　　　　　 server2.Add(new GameService("DataExchange2", 3, "S5DataExchange1"));</p>
<p>　　　　　　　　　　　 server2.Add(new GameService("Rank2", 4, "S5Rank2"));</p>
<p>　　　　　　　　　　　 server2.Add(new GameService("Log2", 5, "S5Log2"));</p>
<p>　　　　　　　　　　　 Element area = new GameArea("电信区");</p>
<p>　　　　　　　　　　　 area.Add(server1);</p>
<p>　　　　　　　　　　　 area.Add(server2);</p>
<p>　　　　　　　　　　　 area.Display();</p>
<p>　　　　　　　　　　　 area.Start();</p>
<p>　　　　　　　　　　　 area.Stop();</p>
<p>　　　　　　　 }</p>
<p>　　　 }</p>
<p>　　　 abstract class Element</p>
<p>　　　 {</p>
<p>　　　　　　　 protected string name;</p>
<p>　　　　　　　 public Element(string name)</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 this.name = name;</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public abstract void Add(Element element);</p>
<p>　　　　　　　 public abstract void Remove(Element element);</p>
<p>　　　　　　　 public abstract void Display();</p>
<p>　　　　　　　 public abstract void Start();</p>
<p>　　　　　　　 public abstract void Stop();</p>
<p>　　　 }</p>
<p>　　　 class GameService : Element, IComparable&lt;GameService&gt;</p>
<p>　　　 {</p>
<p>　　　　　　　 private int serviceType;</p>
<p>　　　　　　　 private string serviceName;</p>
<p>　　　　　　　 public GameService(string name, int serviceType, string serviceName)</p>
<p>　　　　　　　　　　　 : base (name)</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 this.serviceName = serviceName;</p>
<p>　　　　　　　　　　　 this.serviceType = serviceType;</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public override void Add(Element element)</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 throw new ApplicationException("xxx");</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public override void Remove(Element element)</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 throw new ApplicationException("xxx");</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public override void Display()</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 Console.WriteLine(string.Format("name:{0},serviceType:{1},serviceName:{2}", name, serviceType, serviceName));</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public override void Start()</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 Console.WriteLine(string.Format("{0} started", name));</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public override void Stop()</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 Console.WriteLine(string.Format("{0} stopped", name));</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public int CompareTo(GameService other)</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 return other.serviceType.CompareTo(serviceType);</p>
<p>　　　　　　　 }</p>
<p>　　　 }</p>
<p>　　　 class GameServer : Element</p>
<p>　　　 {</p>
<p>　　　　　　　 private string serverIP;</p>
<p>　　　　　　　 private List&lt;GameService&gt; serviceList = new List&lt;GameService&gt;();</p>
<p>　　　　　　　 public GameServer(string name, string serverIP)</p>
<p>　　　　　　　　　　　 : base(name)</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 this.serverIP = serverIP;</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public override void Add(Element element)</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 serviceList.Add((GameService)element);</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public override void Remove(Element element)</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 serviceList.Remove((GameService)element);</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public override void Display()</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 Console.WriteLine(string.Format("{0}{1}({2}){3}", new string('+', 10), name, serverIP, new string('+', 10)));</p>
<p>　　　　　　　　　　　 foreach (Element element in serviceList)</p>
<p>　　　　　　　　　　　 {</p>
<p>　　　　　　　　　　　　　　　 element.Display();</p>
<p>　　　　　　　　　　　 }</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public override void Start()</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 serviceList.Sort();</p>
<p>　　　　　　　　　　　 Console.WriteLine("=============Starting the whole " + name + "=============");</p>
<p>　　　　　　　　　　　 for (int i = 0; i &lt; serviceList.Count; i++ )</p>
<p>　　　　　　　　　　　 {</p>
<p>　　　　　　　　　　　　　　　 serviceList[i].Start();</p>
<p>　　　　　　　　　　　 }</p>
<p>　　　　　　　　　　　 Console.WriteLine("=============The whole " + name + " started=============");</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public override void Stop()</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 Console.WriteLine("=============Stopping the whole " + name + "=============");</p>
<p>　　　　　　　　　　　 for (int i = serviceList.Count -1; i &gt;= 0; i--)</p>
<p>　　　　　　　　　　　 {</p>
<p>　　　　　　　　　　　　　　　 serviceList[i].Stop();</p>
<p>　　　　　　　　　　　 }</p>
<p>　　　　　　　　　　　 Console.WriteLine("=============The whole " + name + " stopped=============");</p>
<p>　　　　　　　 }</p>
<p>　　　 }</p>
<p>　　　 class GameArea : Element</p>
<p>　　　 {</p>
<p>　　　　　　　 private List&lt;GameServer&gt; serverList = new List&lt;GameServer&gt;();</p>
<p>　　　　　　　 public GameArea(string name)</p>
<p>　　　　　　　　　　　 : base(name) { }</p>
<p>　　　　　　　 public override void Add(Element element)</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 serverList.Add((GameServer)element);</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public override void Remove(Element element)</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 serverList.Remove((GameServer)element);</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public override void Display()</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 Console.WriteLine(new string('=',20));</p>
<p>　　　　　　　　　　　 Console.WriteLine("　　　　　　 " + name);</p>
<p>　　　　　　　　　　　 Console.WriteLine(new string('=', 20));</p>
<p>　　　　　　　　　　　 foreach (Element element in serverList)</p>
<p>　　　　　　　　　　　 {</p>
<p>　　　　　　　　　　　　　　　 element.Display();</p>
<p>　　　　　　　　　　　 }</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public override void Start()</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 Console.WriteLine("=============Starting the whole " + name + "=============");</p>
<p>　　　　　　　　　　　 foreach (Element element in serverList)</p>
<p>　　　　　　　　　　　 {</p>
<p>　　　　　　　　　　　　　　　 element.Start();</p>
<p>　　　　　　　　　　　 }</p>
<p>　　　　　　　　　　　 Console.WriteLine("=============The whole " + name + " started=============");</p>
<p>　　　　　　　 }</p>
<p>　　　　　　　 public override void Stop()</p>
<p>　　　　　　　 {</p>
<p>　　　　　　　　　　　 Console.WriteLine("=============Stopping the whole " + name + "=============");</p>
<p>　　　　　　　　　　　 foreach (Element element in serverList)</p>
<p>　　　　　　　　　　　 {</p>
<p>　　　　　　　　　　　　　　　 element.Stop();</p>
<p>　　　　　　　　　　　 }</p>
<p>　　　　　　　　　　　 Console.WriteLine("=============The whole " + name + " stopped=============");</p>
<p>　　　　　　　 }</p>
<p>　　　 }</p>
<p>}</code></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 06:55:37</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/public/" title="public">public</a>, <a href="https://www.iamivan.net/tag/name/" title="name">name</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/writeline/" title="WriteLine">WriteLine</a>, <a href="https://www.iamivan.net/tag/element/" title="element">element</a>, <a href="https://www.iamivan.net/tag/s5pv210/" title="s5pv210">s5pv210</a>, <a href="https://www.iamivan.net/tag/gameserver/" title="gameserver">gameserver</a>, <a href="https://www.iamivan.net/tag/serverip/" title="serverip">serverip</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>无废话C#设计模式之十一：Composite的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB2n9Kb.html" rel="bookmark">无废话C&num;设计模式之二十一：Visitor</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				意图 实现通过统一的接口访问不同类型元素的操作,并且通过这个接口可以增加新的操作而不改变元素的类. 场景 想不出什么好例子,我们在组合模式的那个例子上进行修改吧.我们知道,无论是游戏大区.游戏服务器还是游戏的服务都是一个元素,只不过它们的层次不一样.对于这样的层次结构,我们使用了组合模式来统一各层的接口,这样对游戏大区的操作和对游戏服务器的操作对调用方来说没有什么两样.在现实中,组合模式的运用往往没有这么顺利: l 如果元素需要增加新的操作,那么势必需要在抽象元素中增加接口,这个时候的改动就非常			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZOGxOb.html" rel="bookmark">无废话C&num;设计模式之二十二：总结&lpar;针对GOF23&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文配套源码 比较 设计模式 常用程度 适用层次 引入时机 结构复杂度 Abstract Factory 比较常用 应用级 设计时 比较复杂 Builder 一般 代码级 编码时 一般 Factory Method 很常用 代码级 编码时 简单 Prototype 不太常用 应用级 编码时.重构时 比较简单 Singleton 很常用 代码级.应用级 设计时.编码时 简单 Adapter 一般 代码级 重构时 一般 Bridge 一般 代码级 设计时.编码时 一般 Composite 比较常用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4wXdPp.html" rel="bookmark">无废话C&num;设计模式之五：Prototype</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				意图 用原型实例指定创建对象的种类,并且通过拷贝这些原型创建新的对象. 场景 游戏场景中的有很多相似的敌人,它们的技能都一样,但是随着敌人出现的位置不同,这些人的能力不太一样.假设,我们现在需要把三个步兵组成一队,其中还有一个精英步兵,能力特别高.那么,你或许可以创建一个敌人抽象类,然后对于不同能力的步兵创建不同的子类.然后,使用工厂方法等设计模式让调用方依赖敌人抽象类. 问题来了,如果有无数种能力不同步兵,难道需要创建无数子类吗?还有,步兵模型的初始化工作是非常耗时的,创建这么多步兵对象可能还			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/balvZnz.html" rel="bookmark">无废话C&num;设计模式之一：开篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				什么是设计模式? 什么是少林拳呢?少林拳是少林僧人经过长期的总结,得出的一套武功套路.有一本叫做少林拳法的武功秘籍,上面记载这这套拳法的适用人群,打法套路和学成后的效果.设计模式虽然记录在了设计模式一书上,但是要真正掌握设计模式光靠看每一个模式的结构并且进行模仿是不够的.试想一下,在真枪实战的情况下,谁会和你按照少林拳法,一二三四的套路打呢?打套路也只能用来看看,只有当你能根据不同的场景灵活出招的时候才能说是学会了这套拳法.相似的例子还有三十六计,这也是一种模式,每种计谋都是针对不同场景的,如果			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK7x9Lb.html" rel="bookmark">无废话C&num;设计模式之十四：Template Method</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				意图 定义一个操作中的算法的骨架,而将一些步骤延迟到子类中.Template Method使得子类可以不改变一个算法的结构即可重定义该算法的某些特定步骤. 场景 模版方法是非常容易理解的设计模式,一来是因为它没有过多结构上的交错,二来是因为这种代码复用技术对于掌握OO知识的人来说非常容易可以想到,很可能你已经在很多地方运用了模版方法.在运用一些设计模式的时候常常也会一起运用模版方法,甚至有的设计模式本身就带有模版方法的思想. 今天,我们给出这样一个实际的例子.做过银行支付.支付宝支付的人都知道,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGjoeop.html" rel="bookmark">无废话C&num;设计模式之八：Facade</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				意图 为子系统中的一组接口提供一个一致的界面,Facade模式定义了一个高层接口,这个接口使得这一子系统更加容易使用. 场景 在一个为游戏充值的网站中,创建订单需要与三个外部接口打交道: l 用户系统:根据用户名获取用户ID.查看用户是否已经激活了游戏 l 卡系统:查看某种类型的充值卡是否还有库存 l 充值系统:创建一个订单,并且返回订单号 如果直接让网站和三个外部接口发生耦合,那么网站因为外部系统接口修改而修改的概率就很大了,并且就这些小接口来说并不是十分友善,它们提供的大多数是工具方法,具体			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxPDaOM.html" rel="bookmark">无废话C&num;设计模式之七：Adapter</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				意图 把一个类的接口变换成客户端所期待的另一种接口,从而使原本接口不匹配而无法在一起工作的两个类能够在一起工作. 场景 假设网络游戏的客户端程序分两部分.一部分是和服务端通讯的大厅部分,大厅部分提供的功能有道具购买.读取房间列表.创建房间以及启动游戏程序.另一部分就是游戏程序了,游戏程序和大厅程序虽然属于一个客户端,但是由不同的公司在进行开发.游戏大厅通过实现约定的接口和游戏程序进行通讯. 一开始的设计就是,大厅程序是基于接口方式调用游戏程序启动游戏场景方法的.在大厅程序开发接近完成的时候,公司			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj7Gl5M.html" rel="bookmark">无废话C&num;设计模式之六：Builder</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				意图 将一个复杂的构建与其表示相分离,使得同样的构建过程可以创建不同的表示. 场景 在电脑城装机总有这样的经历.我们到了店里,先会有一个销售人员来询问你希望装的机器是怎么样的配置,他会给你一些建议,最终会形成一张装机单.和客户确定了装机配置以后,他会把这张单字交给提货的人,由他来准备这些配件,准备完成后交给装机技术人员.技术人员会把这些配件装成一个整机交给客户. 不管是什么电脑,它总是由CPU.内存.主板.硬盘以及显卡等部件构成的,并且装机的过程总是固定的: l 把主板固定在机箱中 l 把CPU			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOw588z.html" rel="bookmark">无废话C&num;设计模式之四：Factory Method</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				意图 定义一个创建产品对象的工厂接口,将实际创建工作推迟到子类中. 场景 上次,我们使用抽象工厂解决了生产一组产品的问题,但是我们把各个场景作为了具体工厂来生产场景模式和场景纹理两个产品.在调用代码中也并没有出现具体工厂的影子.其实,场景类要做的不仅仅是创建具体的产品系列,可能它还需要做一个初始化工作.那么,我们就需要在调用代码中能得到这个场景类. 在前一节中,由于场景类(比如HalfPaper)本身是具体级别的(具体工厂).那么,我们也不应该在调用代码中直接依赖场景类.因此,我们可以使用工厂方			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bo3ADb.html" rel="bookmark" class="title">Xml WebService完全实例解析&lpar;三&rpar;</a>
					<div>
						web|xml 接上篇文章,我们先简单解释下GetSiteAData(string AssignName)函数.          函数功能很简单,只是要返回查询结果,其数据格式是XmlDataDoc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4VkJM.html" rel="bookmark" class="title">C&num;3&period;0新特性之隐式类型局部变量的使用</a>
					<div>
						变量 首先说明一下,此新特性的专题基于MS五月份分布的C#3.0规范,但是官方中文版还没有出来,结合自己的实践和理解,希望能和大家一起分享某些前沿的东东,很有可能一些地方会出错,望抛砖. 在C# 3. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1XNnz.html" rel="bookmark" class="title">sql server 2008 R2 故障恢复移动文件</a>
					<div>
						朋友咨询的问题,这里给个参考步骤: 故障恢复移动文件 /* 如果数据 库无法启动,即处于可疑模式下或处于未恢复状态,则只有 sysadmin 固定角色的成员才可 以移动该文件. */ 1.如果启动了  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6JXjz.html" rel="bookmark" class="title">linux系统中如何构建LAMP网站服务平台</a>
					<div>
						一.安装httpd服务器 1.编辑安装 在配置Apache Web服务器之前,需要正确安装好httpd服务器软件. 1). 获取软件包 2). 解压并释放源码包 3). 配置编译选项 在配置前可以先执 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBR3Lb.html" rel="bookmark" class="title">Delphi格式化输出函数&lpar;3&rpar;&colon; FormatFloat</a>
					<div>
						var s: string;begin //FormatFloat 的参数1是 String 格式指令, 参数2是实数类型 Extended s := FormatFloat('###.###',12 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvK6eNp.html" rel="bookmark" class="title">Word入门动画教程37：文本的选定</a>
					<div>
						第三十七讲:选定文本 如果要对文档的某部分进行复制.移动.删除.更改格式等操作,首先要先选中这些内容.基本的选择方法是: 在要选定的文字开始处按住鼠标左键不放,拖动鼠标到结束处再放开.被选定的文本将以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jevZb.html" rel="bookmark" class="title">在J2ME手机编程中使用字体和颜色</a>
					<div>
						使用字体 在J2ME手机编程中,可以通过使用字体类--Font在低级用户界面中,获得更好的表现效果,那么如何使用Font类呢? 首先,由于手机设备的限制,手机中支持的字体类型很有限,所以在J2ME中只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6eNdAb.html" rel="bookmark" class="title">怎样避免U盘导致的数据泄露</a>
					<div>
						  怎样避免U盘导致的数据泄露           随着u盘使用越来越频繁,给我们带来方便的同时也使泄密情况越来越严重,有没有什么好办法保护我们U盘里的数据更好的保护起来呢?现在来说说这方面的一个技巧 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLnmOb.html" rel="bookmark" class="title">解决Win7在休眠时会掉网的问题</a>
					<div>
						  问:我的电脑是Win7系统64位的,之前的设置休眠时网络都是正常连接的,可是最近不知道修改了什么,一休眠就断网了,休眠的时候都无法下载了,请问该如何设置让休眠的时候可以继续下载啊? 答:这个问题其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwL3kvb.html" rel="bookmark" class="title">金色数值&lpar;金色的CMYK的值是多少&rpar;</a>
					<div>
						金色随亮度.深浅.色相的不同CMYK值变化也很大,金色和印刷图案中的其他色彩统一分色即可.如果你想金光闪闪的效果,只能使用胶印金墨.使用4色墨达不到这一效果. 只能是印刷假金色,具体数值:C=20-3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjrQlb.html" rel="bookmark" class="title">office2016可装在什么系统上？</a>
					<div>
						  office2016可装在什么系统上?作为微软最新的办公软件,office2016收到了很多网友的关注,可能网友都知道,office2016可以在win10系统上安装,但是,大家知道安装offic ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3jemp.html" rel="bookmark" class="title">Flink-CEP之带版本的共享缓冲区</a>
					<div>
						带版本的共享缓冲区 当股票模式以一个事件流作为输入时,状态转换将会作用于事件流从而引起事件的状态变化.结合窗口对参与匹配的事件的限制以及模式中结合事件上下文(状态)的过滤条件,同一事件流随着时间的流动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lr38b.html" rel="bookmark" class="title">vc60-问各位一下，VC6&period;0会因为代码执行的时间过长，而终止运行</a>
					<div>
						问题描述 问各位一下,VC6.0会因为代码执行的时间过长,而终止运行 如下程序: #include #include struct PolyNode { float coef; int exp; Po ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NZaLM.html" rel="bookmark" class="title">cmd-java中调用命令行，可执行文件带有参数如何设置？</a>
					<div>
						问题描述 java中调用命令行,可执行文件带有参数如何设置? 我在使用哈工大分词LTP二进制版本 命令如下 ltp_test --input C:UsersadminDesktoptest2.txt  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YqYoM.html" rel="bookmark" class="title">Java多线程与并发库高级应用</a>
					<div>
						想快速精通多线程?看这里  http://blog.chinaunix.net/uid-540802-id-4431193.html 什么是线程         线程,是程序执行流的最小单元.是进程中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWQ21p.html" rel="bookmark" class="title">new-&lbrack;Android&rsqb;关于 handler 的应用</a>
					<div>
						问题描述 [Android]关于 handler 的应用 handler.postDelayed(new Runnable(){ public void run() { handler.postDel ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7JN8M.html" rel="bookmark" class="title">c&num; 百思不得其解&colon;word一页得到的图片与原始大小不一致&comma;有源码有数据&comma;请测试</a>
					<div>
						问题描述 c# 百思不得其解:word一页得到的图片与原始大小不一致,有源码有数据,请测试 根据网上的一些大神的代码及帮助文档,做了一个word转图片的程序.简要测试一下,发现转换出来的图片跟原始文档 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEVA3M.html" rel="bookmark" class="title">【智驾深谈】一张图看清自动驾驶产业</a>
					<div>
						自动驾驶三层次 通常来讲,自动驾驶技术可以划分为三个层次,感知-&gt;认知-&gt;行动,然后不断循环.参考上面一张网图,其中行动层包括转向.油门和制动三大控制器(以及执行机构),感知部分包括两方面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqR4RYp.html" rel="bookmark" class="title">Android Service和广播联合更新UI的例子</a>
					<div>
						在Android中,异步更新UI,通常我们会选用Handler启动线程,或者sendMessage的方式,那么利用Service和广播也可以更新UI的,例子如下:我们建立一个Service: pack ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZJ9Bz.html" rel="bookmark" class="title">仿百度壁纸客户端（二）&mdash;&mdash;主页自定义ViewPager广告定时轮播图</a>
					<div>
						仿百度壁纸客户端(二)--主页自定义ViewPager广告定时轮播图 百度壁纸系列 仿百度壁纸客户端(一)--主框架搭建,自定义Tab + ViewPager + Fragment 仿百度壁纸客户端( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjYPQM.html" rel="bookmark" class="title">【dotnet跨平台】微软昨天宣布正式发布&period;NET Core RC2和&period;NET Core SDK Preview 1，还有Entity Framework Core RC2</a>
					<div>
						﻿﻿ [dotnet跨平台]微软昨天宣布正式发布.NET Core RC2和.NET Core SDK Preview 1,还有Entity Framework Core RC2 期待已经的版本终于在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvngE6M.html" rel="bookmark" class="title">【曹操】【js-sequence-diagrams】前端js绘制时序图</a>
					<div>
						背景说明:     因为最近在开发一个新的项目,代号曹操,后续可能会更新许多曹操项目相关的开发技术博文,见证曹操项目的从0到上线到最终的产品,也见证自己从java后台到前端全栈到最后全战的开发dog. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXAJ5b.html" rel="bookmark" class="title">《Linux KVM虚拟化架构实战指南》&mdash;&mdash;1&period;4 OpenStack技术介绍</a>
					<div>
						1.4 OpenStack技术介绍 OpenStack是一个云平台管理的项目,它不是一个软件,它是美国国家航空航天局和Rackspace合作研发的,以Apache许可证授权,并且是一个自由软件和开放源 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKP0lM.html" rel="bookmark" class="title">郑欣宜想收郑少秋大红包最好是&OpenCurlyDoubleQuote;支票红包&rdquo;</a>
					<div>
						郑欣宜期待收到父亲大红包,笑称越大封越好 新浪娱乐讯 北京时间2月5日消息,据香港媒体报道,郑欣宜表示会向父亲郑少秋拜年,更声称想收到父亲的&quot;支票&quot;红包,越大越好:&quot;之前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYQqqb.html" rel="bookmark" class="title">Javascript基础知识（三）BOM，DOM总结&lowbar;基础知识</a>
					<div>
						window对象: 打开和关闭窗口: window.open() 三个参数:1.载入新窗口的页面的URL   2.新窗口的名字   3.特性字符串和说明是否用新载入的页面替换当前载入的页面的Boole ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBk0PoM.html" rel="bookmark" class="title">FckEditor 中文配置手册&lowbar;网页编辑器</a>
					<div>
						[摘要] 性能 首先,FCKEDITOR的性能是非常好的,用户只需很少的时间就可以载入FCKEDITOR所需文件.对于其他在线编辑器来说,这几乎是个很难解决的难题,因为在开启编辑器时需要装载太多的文件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmQ6mz.html" rel="bookmark" class="title">mvc 视图刷新</a>
					<div>
						问题描述 点击下载刷新下载数 解决方案 解决方案二:直接执行一个ajax请求,直接js更新数字,不用等后台响应解决方案三:前台直接JS给下载数+1然后后台请求资源的时候更新下资源的下载数解决方案四:求 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8G6Y4M.html" rel="bookmark" class="title">Go语言中的if条件语句使用详解&lowbar;Golang</a>
					<div>
						if语句if语句包含一个布尔表达式后跟一个或多个语句. 语法 if语句在Go编程语言的语法是: 复制代码 代码如下: if(boolean_expression) {    /* statement( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqgyO2z.html" rel="bookmark" class="title">怎样将htm文件或exe文件在C&num;编写的程序中显示出来，应该用何种控件？</a>
					<div>
						问题描述 怎样将htm文件或exe文件在C#编写的程序中显示出来,应该用何种控件? 解决方案 解决方案二:webbrowser控件					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenXZ8b.html" rel="bookmark" class="title">爱奇艺独家上线《名侦探柯南》</a>
					<div>
						日前,高清视频网站爱奇艺正式开播&quot;柯南剧场&quot;,独家上线日本人气动漫剧集&lt;名侦探柯南&gt;.这一播出终结了&lt;名侦探柯南&gt;多年来在内地网络播出无正规版权的尴尬.作为 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
